gdjs.evtsExt__TextureHack__loadTexturePack = {};

gdjs.evtsExt__TextureHack__loadTexturePack.conditionTrue_0 = {val:false};
gdjs.evtsExt__TextureHack__loadTexturePack.condition0IsTrue_0 = {val:false};


gdjs.evtsExt__TextureHack__loadTexturePack.userFunc0x6d5e48 = function(runtimeScene, eventsFunctionContext) {
"use strict";
function loadZippedTexurePack(zip) {
    return new JSZip().loadAsync(zip)
    .then(zip => {
        const imageManager = runtimeScene.getGame().getImageManager();
        let loaders = [];
        zip.forEach(function(file) {
            loaders.push(
                zip.file(file).async("blob")
                .then(resourceFile => {
                    return new Promise((resolveReader) => {
                        // Convert blob to dataurl
                        const blobURL = URL.createObjectURL(resourceFile);
                        var img = new Image();
                        img.addEventListener("load", function(event){URL.revokeObjectURL(blobURL);});
                        img.src = blobURL;
                        // Load it in memory
                        imageManager._loadedTextures.put(file, new PIXI.Texture(new PIXI.BaseTexture(img)));
                        resolveReader();
                    });
                })
            );
        });
        // When all loaded
        return Promise.all(loaders);  
    });
}

const e = runtimeScene.getGame().getRenderer().getElectron();
console.log("f")
if(e == null) { // Normal HTML5 loading
    let w = window.open("about:blank");
    // Prepare zip input
    let input = w.document.createElement("input");
    input.type = "file";
    input.multiple = true;
    input.accept="application/zip";
    input.style.opacity = "0";
    // When File loaded
    input.onchange = function() {
        let packs = []
        input.files.forEach((zip) => {
            packs.push(loadZippedTexurePack(zip));
        })
        Promise.all(packs).then(() => { // When all packs loaded
            document.body.removeChild(input);
            // Reload scene
            // This is required to make sure all PIXI objects are deleted and recreated using the new textures.
            // We cannot request change as promises run between two frames and not in the event loop:
            // We need to manually change it.
            runtimeScene.getGame()._sceneStack.replace(eventsFunctionContext.getArgument("scene"), true);
        });
    }
    // Start file selection
    w.document.body.appendChild(input);
    input.click();
} else {// Electron specific loading as input with file type are not supported
    e.remote.dialog.showOpenDialog({
        title: "Load Texture Pack", 
        filters: [{name:"Zipped Texture Pack", extensions: ["zip"]}],
        properties: ["multiSelections"]
    })
    .then(result => {
        if(result.canceled) return;
        let packs = [];
        console.log(result.filePaths)
        result.filePaths.forEach((packFile) => {
            let zip = require("fs").readFileSync(packFile);
            console.log(packFile)
            packs.push(loadZippedTexurePack(zip));
        })
        Promise.all(packs)
        .then(() => { // When all packs loaded
            // Reload scene
            // This is required to make sure all PIXI objects are deleted and recreated using the new textures.
            // We cannot request change as promises run between two frames and not in the event loop:
            // We need to manually change it.
            runtimeScene.getGame()._sceneStack.replace(eventsFunctionContext.getArgument("scene"), true);
        });
    })
}

};
gdjs.evtsExt__TextureHack__loadTexturePack.eventsList0x5b7f18 = function(runtimeScene, eventsFunctionContext) {

{


gdjs.evtsExt__TextureHack__loadTexturePack.userFunc0x6d5e48(runtimeScene, typeof eventsFunctionContext !== 'undefined' ? eventsFunctionContext : undefined);

}


}; //End of gdjs.evtsExt__TextureHack__loadTexturePack.eventsList0x5b7f18


gdjs.evtsExt__TextureHack__loadTexturePack.func = function(runtimeScene, scene, parentEventsFunctionContext) {
var eventsFunctionContext = {
  _objectsMap: {
},
  _objectArraysMap: {
},
  _behaviorNamesMap: {
},
  getObjects: function(objectName) {
    return eventsFunctionContext._objectArraysMap[objectName] || [];
  },
  getObjectsLists: function(objectName) {
    return eventsFunctionContext._objectsMap[objectName] || null;
  },
  getBehaviorName: function(behaviorName) {
    return eventsFunctionContext._behaviorNamesMap[behaviorName];
  },
  createObject: function(objectName) {
    var objectsList = eventsFunctionContext._objectsMap[objectName];
    if (objectsList) {
      return parentEventsFunctionContext ?
        parentEventsFunctionContext.createObject(objectsList.firstKey()) :
        runtimeScene.createObject(objectsList.firstKey());
    }
    return null;
  },
  getArgument: function(argName) {
if (argName === "scene") return scene;
    return "";
  }
};


gdjs.evtsExt__TextureHack__loadTexturePack.eventsList0x5b7f18(runtimeScene, eventsFunctionContext);
return;
}

